#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include "callbacks.h"
#include "interface.h"
#include "support.h"

/*Global Variables are declared here*/
const gchar *selected_filename="";
char *tstart,*tend;
GtkWidget *dest_folder,*start_time,*end_time,*message,*window1,*pbar;
char wg[200]="wget -b ",temp[50]="0";
int rad_val = 0,cookie_val = 0;
char a[20];


int fileexists=0;

float fraction;


void setprogress();
void getstat(char[]);
char* gettime();
int hostfound();


/*This is the browse button*/
/*Used to select destination folder to save downloaded files*/
void
on_button1_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	create_file_selection();
	dest_folder = lookup_widget(GTK_WIDGET(button),"entry1");
}


/*Code for Download button, Actual download takes here*/
void
on_button2_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{

        char *URL_name,*Max_speed,*Max_size;        
	char str[30]="date > t.txt";
	int host;
	
	//wg=(char *)malloc(200 * sizeof(char *));
	//wg="wget -b ";
	window1=lookup_widget(GTK_WIDGET(button),"window1");
	
	GtkWidget *URL_entry = lookup_widget(GTK_WIDGET(button),"entry2");
	GtkWidget *Speed_entry = lookup_widget(GTK_WIDGET(button),"entry3");
	GtkWidget *Size_entry = lookup_widget(GTK_WIDGET(button),"entry4");

	/*Labels to display the Start time*/
	GtkWidget *start_time_lab =lookup_widget(GTK_WIDGET(button),"label17");
	start_time =lookup_widget(GTK_WIDGET(button),"label6");

	/*Labels to display the End time*/
	GtkWidget *end_time_lab = lookup_widget(GTK_WIDGET(button),"label18");
	end_time = lookup_widget(GTK_WIDGET(button),"label7");

	
	URL_name = gtk_entry_get_text(URL_entry);

	Max_speed = gtk_entry_get_text(Speed_entry);
	Max_size = gtk_entry_get_text(Size_entry);

	/*enables to set speed of download*/
	if((strcmp(Max_speed,"0")) == 0){
	}
	else{
	strcat(Max_speed,"m");
	strcat(wg," --limit-rate=");
	strcat(wg,Max_speed);
	strcat(wg," ");
	}

	/*to set maximum download limit of the files*/
	if((strcmp(Max_size,"0")) == 0){
	}
	else{
	strcat(Max_size,"m");
	strcat(wg," -Q");
	strcat(wg,Max_size);
	strcat(wg," ");
	}
	
	/*checks whether URL field is empty */
	if((strcmp(URL_name,""))==0)
	  {
	    message=gtk_message_dialog_new(window1,GTK_DIALOG_DESTROY_WITH_PARENT,GTK_MESSAGE_ERROR,GTK_BUTTONS_OK,"URL field cannot be empty");
	    gtk_dialog_run(GTK_DIALOG(message));
	    gtk_widget_destroy(message);
	   }
	
	else
	  {

	    system(str);
	    tstart=gettime();
	    //gtk_label_set_label(start_time,tstart);
	    //gtk_label_set_label(start_time_lab,"DownloadStartedAt ");
	    strcat(wg,URL_name);
	  	
	    /*disables cookie*/
	    if(cookie_val == 0){
	      strcat(wg," --cookie=on ");
	    }
	    else{
	      strcat(wg," --cookie=off ");
	    }

	    /*Here request for index file only or all files is checked*/
	    if(rad_val == 0){
	      strcat(wg,"");
	    }
	    else{
	      strcat(wg," -r ");
	    }

	    /*checks whether destination is empty */
	    if((strcmp(selected_filename,""))==0)
	      {
		message=gtk_message_dialog_new(window1,GTK_DIALOG_DESTROY_WITH_PARENT,GTK_MESSAGE_INFO,GTK_BUTTONS_OK,"Destination field is empty. Files will be downloaded in the current directory");
		gtk_dialog_run(GTK_DIALOG(message));
		gtk_widget_destroy(message);

	      }
	    else
	      {
		strcat(wg," -P ");
		strcat(wg,selected_filename);
	      }
	    
	    system(wg);
	    	    
	   

	    //sleep(1);
	    getstat(temp);
	    system(str);
	    tend=gettime();	
	    /* check if download has taken place.. */
	    host=hostfound();
	    
	    
	    if(host==1)
	      {
		message=gtk_message_dialog_new(window1,GTK_DIALOG_DESTROY_WITH_PARENT,GTK_MESSAGE_ERROR,GTK_BUTTONS_OK,"Host Not Found");
		gtk_dialog_run(GTK_DIALOG(message));
		gtk_widget_destroy(message);
		system("rm wget-log*");
	      }
	    else
	    {
	      /*
		gtk_label_set_label(end_time_lab,"DownloadCompleted");
		gtk_label_set_label(end_time,tend);
	      */
		message=gtk_message_dialog_new(window1,GTK_DIALOG_DESTROY_WITH_PARENT,GTK_MESSAGE_INFO,GTK_BUTTONS_OK,"Download Completed At:   %s",tend);
		system("rm wget-log*");
		gtk_dialog_run(GTK_DIALOG(message));
		gtk_widget_destroy(message);
		
		 }
	    
	    fileexists=1;	  	
	    //wg="wget -b";

	   
	    }
	  

}


/* The file selection widget and the string to store the chosen filename */

void store_filename (GtkWidget *widget, gpointer user_data) {
   GtkWidget *file_selector = GTK_WIDGET (user_data);

   selected_filename = gtk_file_selection_get_filename (GTK_FILE_SELECTION (file_selector));
   
	gtk_entry_set_text(dest_folder,selected_filename);
}

void create_file_selection (void) {

   GtkWidget *file_selector;

   /* Create the selector */
   
   file_selector = gtk_file_selection_new ("Please select a destination folder");
      
   g_signal_connect (GTK_FILE_SELECTION (file_selector)->ok_button,
                     "clicked",
                     G_CALLBACK (store_filename),
                     file_selector);
   			   
   /* Ensure that the dialog box is destroyed when the user clicks a button. */
   
   g_signal_connect_swapped (GTK_FILE_SELECTION (file_selector)->ok_button,
                             "clicked",
                             G_CALLBACK (gtk_widget_destroy), 
                             file_selector);

   g_signal_connect_swapped (GTK_FILE_SELECTION (file_selector)->cancel_button,
                             "clicked",
                             G_CALLBACK (gtk_widget_destroy),
                             file_selector); 
   
   /* Display that dialog */
   
   gtk_widget_show (file_selector);
}


void
on_radiobutton1_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  rad_val = 0;
}


void
on_radiobutton2_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  rad_val = 1;
}


void
on_checkbutton1_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  strcat(wg," -k ");
}


void
on_checkbutton2_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  strcat(wg," -p ");
}


void
on_checkbutton3_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  strcat(wg," -nc ");
}


void
on_checkbutton4_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  strcat(wg," -c ");
}

/*combo box which enables number of tries*/
void
on_comboboxentry1_changed              (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
  int no_of_tries;

  GtkWidget *try_combo = lookup_widget(GTK_WIDGET(combobox),"comboboxentry1");

  no_of_tries = gtk_combo_box_get_active(try_combo);

  switch(no_of_tries)
    {
    case 0:
      strcat(wg," -t 0 ");
      break;
    case 1:
      strcat(wg," -t 1 ");
      break;
    case 2:
      strcat(wg," -t 2 ");
      break;
    case 3:
      strcat(wg," -t 3 ");
      break;
    case 4:
      strcat(wg," -t 4 ");
      break;
    case 5:
      strcat(wg," -t 5 ");
      break;
    case 6:
      strcat(wg," -t 6 ");
      break;
    case 7:
      strcat(wg," -t 7 ");
      break;
    case 8:
      strcat(wg," -t 8 ");
      break;
    case 9:
      strcat(wg," -t 9 ");
      break;
    case 10:
      strcat(wg," -t 10 ");
      break;
    default:
      strcat(wg,"");
    }

}

/*combo box which specifies the depth of the files to be downloaded*/
void
on_comboboxentry2_changed              (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
  int depth;

  GtkWidget *depth_combo = lookup_widget(GTK_WIDGET(combobox),"comboboxentry2");
  depth = gtk_combo_box_get_active(depth_combo);

  switch(depth)
    {
    case 0:
      strcat(wg," -l 1 ");
    case 1:
      strcat(wg," -l 2 ");
      break;
    case 2:
      strcat(wg," -l 3 ");
      break;
    case 3:
      strcat(wg," -l 4 ");
      break;
    case 4:
      strcat(wg," -l 5 ");
      break;
    case 5:
      strcat(wg," -l 6 ");
      break;
    case 6:
      strcat(wg," -l 7 ");
      break;
    case 7:
      strcat(wg," -l 8 ");
      break;
    case 8:
      strcat(wg," -l 9 ");
      break;
    case 9:
      strcat(wg," -l 10 ");
      break;
    default:
      strcat(wg,"");
    }

}


/*This code distroys the main window of GetEz*/

void
on_fixed1_destroy                      (GtkObject       *object,
                                        gpointer         user_data)
{
  if(fileexists==1){
    system("rm stat.txt t.txt");
  }
  else{}
  gtk_main_quit();
}


void
on_checkbutton5_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  cookie_val = 1;
}

/*disables caching*/
void
on_checkbutton6_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  strcat(wg," -C off ");
}


void
on_checkbutton7_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  strcat(wg," -g off ");
}


void
on_checkbutton8_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  strcat(wg," --passive-ftp ");
}


void
on_checkbutton9_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  strcat(wg," -nr ");
}

void getstat(char temp[]){

  FILE *fp;
  char g[100];
  int i=0;
  double s1,s2;
  char str[100]="stat wget-log -c %s >stat.txt";

  system(str);

  fp = fopen("stat.txt","r");

  while( (g[i] = getc(fp)) != EOF){
     i++;
  }
    g[--i] = '\0';

  if((strcmp(temp,g) == 0)){

    return;
  }
  else{
      temp=g;
  }

  fclose(fp);
  sleep(2);

getstat(temp);
}

char* gettime()
{
  FILE *fp;
  // char a[20];
  int i=0;
  fp=fopen("t.txt","r");
  while((a[i]=getc(fp))!=EOF){
    i++;
  }
  a[--i]='\0';
  fclose(fp);
  return a;

}

int hostfound()
{
  FILE *fp;
  char a[50]="grep -c failed wget-log > host.txt";
  char ho[10];
  int i=0,j;
  
  system(a);

  fp=fopen("host.txt","r");
  while((ho[i]=getc(fp))!=EOF){
    i++;
  }
  ho[--i]='\0';

  j=atoi(ho);

  fclose(fp);

  //  system("rm wget-log*");  

  if(j > 0)
    return 1;
  else
    return 0;


}
